package com.gic.haoban.manage.service.util;

import com.gic.commons.util.StringUtil;
import com.vdurmont.emoji.EmojiParser;
import org.apache.commons.lang3.StringUtils;

public class EmojiFilterUtil {

    public static String removeAllEmoji(String content) {
        if (StringUtils.isBlank(content)) {
            return content;
        }
        String s = EmojiParser.removeAllEmojis(content);
        if (StringUtils.isBlank(s)) {
            return "未知用户";
        }
        String ret = EmojiFilterUtil.filterEmojiLast(s, false);
        if (StringUtils.isBlank(ret)) {
            return "未知用户";
        }
        return ret;
    }

    /**
     * @param isPharse 是否是短语 若是短语则 超过20字符编程*
     */
    public static String filterEmojiLast(String content, boolean isPhrase) {
        byte[] conbyte = content.getBytes();
        for (int i = 0; i < conbyte.length; i++) {
            if ((conbyte[i] & 0xF8) == 0xF0) {
                for (int j = 0; j < 4; j++) {
                    conbyte[i + j] = 0x30;
                }
                i += 3;
            }
        }
        content = new String(conbyte);
        return filterEmoji(content.replaceAll("0000", ""), isPhrase);
    }

    private static String filterEmoji(String source, boolean isPhrase) {
        if (!containsEmoji(source)) {
            return source;// 如果不包含，直接返回
        }
        // 到这里铁定包含
        StringBuilder buf = null;
        int len = source.length();
        if (len > 100 && isPhrase) {
            return "*";
        }
        for (int i = 0; i < len; i++) {
            char codePoint = source.charAt(i);
            if (isEmojiCharacter(codePoint)) {
                if (buf == null) {
                    buf = new StringBuilder(source.length());
                }
                buf.append(codePoint);
            }
        }
        if (buf == null) {
            return source;// 如果没有找到 emoji表情，则返回源字符串
        } else {
            if (buf.length() == len) {// 这里的意义在于尽可能少的toString，因为会重新生成字符串
                buf = null;
                return source;
            } else {
                return buf.toString();
            }
        }
    }

    private static boolean isEmojiCharacter(char codePoint) {
        return (codePoint == 0x0) || (codePoint == 0x9) || (codePoint == 0xA) || (codePoint == 0xD)
                || ((codePoint >= 0x20) && (codePoint <= 0xD7FF)) || ((codePoint >= 0xE000) && (codePoint <= 0xFFFD))
                || ((codePoint >= 0x10000) && (codePoint <= 0x10FFFF));
    }

    // 判断表情符
    private static boolean containsEmoji(String source) {
        if (StringUtil.isBlank(source)) {
            return false;
        }
        source = source.replaceAll("[\\ud800\\udc00-\\udbff\\udfff\\ud800-\\udfff]", "*");
        int len = source.length();
        for (int i = 0; i < len; i++) {
            char codePoint = source.charAt(i);
            if (isEmojiCharacter(codePoint)) {
                // do nothing，判断到了这里表明，确认有表情字符
                return true;
            }
        }
        return false;
    }
}
